Index: orxonox/branches/levelloader/src/INSTALL
===================================================================
--- orxonox/branches/levelloader/src/INSTALL	(revision 3604)
+++ orxonox/branches/levelloader/src/INSTALL	(revision 3605)
@@ -3,10 +3,32 @@
 =====================================
 
-Installing an using orx is very simple: Just type:
+INSTALLATION
+============
 
-cd ../orxonox/trunk
-./configure
-make
-./bin/orxonox
+To make it quite easy for those of you who just want to install orxonox:
+
+1. ./configure
+2. make
+3. make install
+
+DEPENDENCIES
+============
+
+There are some dependencies for orxonox you have to install:
+
+1. SDL           (http://www.libsdl.org)
+2. OPENGL        (http://www.opengl.org)
+3. SDL_mixer     (http://www.libsdl.org/projects/SDL_mixer)
+4. SDL_image     (http://www.libsdl.org/projects/SDL_image)
+5. SDL_ttf       (http://www.libsdl.org/projects/SDL_ttf)
+ a) needs libttf (http://www.freetype.org/)
+
+Nice to Have:
+6. Doxygen       (http://www.stack.nl/~dimitri/doxygen/)
+7. Automake	 (http://www.gnu.org/software/automake/)
+8. Autoconf      (http://www.gnu.org/software/autoconf/)
+
+Windows Users also need the following:
+9. mingw         (http://mingw.org/)
 
 
Index: orxonox/branches/levelloader/src/Makefile.am
===================================================================
--- orxonox/branches/levelloader/src/Makefile.am	(revision 3604)
+++ orxonox/branches/levelloader/src/Makefile.am	(revision 3605)
@@ -6,5 +6,5 @@
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/coord
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/data
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gaphics
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/font
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/importer
@@ -34,5 +34,6 @@
 		 camera.cc \
 		 track_manager.cc \
-		 light.cc \
+		 track_node.cc \
+		 simple_animation.cc \
 		 factory.cc \
 		 story_entities/story_entity.cc \
@@ -43,4 +44,9 @@
 		 world_entities/environment.cc \
 		 world_entities/skysphere.cc \
+		 world_entities/terrain.cc \
+		 world_entities/primitive.cc \
+		 world_entities/weapon.cc \
+		 world_entities/projectile.cc \
+		 world_entities/character_attributes.cc \
 		 ai/ai.cc \
 		 lib/coord/p_node.cc \
@@ -48,4 +54,5 @@
 		 lib/coord/helper_parent.cc \
 		 lib/data/data_tank.cc \
+		 lib/graphics/light.cc \
 		 lib/graphics/font/fontset.cc \
 		 lib/graphics/importer/array.cc \
@@ -60,5 +67,4 @@
 		 lib/util/substring.cc \
 		 lib/math/vector.cc \
-		 lib/math/matrix.cc \
 		 lib/math/curve.cc \
 		 lib/xmlparser/tinystr.cc \
@@ -77,5 +83,7 @@
 		 command_node.h \
 		 message_structures.h \
-		 light.h \
+		 track_manager.h \
+		 track_node.h \
+		 simple_animation.h \
 		 story_entities/story_entity.h \
 		 story_entities/story_def.h \
@@ -87,7 +95,10 @@
 		 world_entities/environment.h \
 		 world_entities/skysphere.h \
-		 world_entities/shoot_laser.h \
-		 world_entities/shoot_rocket.h \
 		 world_entities/power_up.h \
+		 world_entities/terrain.h \
+		 world_entities/primitive.h \
+		 world_entities/weapon.h \
+		 world_entities/projectile.h \
+		 world_entities/character_attributes.h \
 		 ai/ai.h \
 		 network/synchronisable.h \
@@ -99,4 +110,5 @@
 		 lib/coord/null_parent.h \
 		 lib/coord/helper_parent.h \
+		 lib/graphics/light.h \
 		 lib/graphics/font/fontset.h \
 		 lib/data/data_tank.h \
@@ -110,5 +122,4 @@
 		 lib/xmlparser/tinystr.h \
 		 lib/math/vector.h \
-		 lib/math/matrix.h \
 		 lib/math/curve.h \
 		 glmenu/glmenu_imagescreen.h 
@@ -119,5 +130,5 @@
 
 if SUB_PROJECTS
-  SUB_PROGS = lib
+  SUB_PROGS = lib subprojects
 else
   SUB_PROGS = 
Index: orxonox/branches/levelloader/src/ability.h
===================================================================
--- orxonox/branches/levelloader/src/ability.h	(revision 3604)
+++ orxonox/branches/levelloader/src/ability.h	(revision 3605)
@@ -10,5 +10,5 @@
  public:
   Ability ();
-  ~Ability ();
+  virtual ~Ability ();
 
 };
Index: orxonox/branches/levelloader/src/ai/ai.h
===================================================================
--- orxonox/branches/levelloader/src/ai/ai.h	(revision 3604)
+++ orxonox/branches/levelloader/src/ai/ai.h	(revision 3605)
@@ -9,5 +9,5 @@
  public:
   AI ();
-  ~AI ();
+  virtual ~AI ();
 
 };
Index: orxonox/branches/levelloader/src/camera.cc
===================================================================
--- orxonox/branches/levelloader/src/camera.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/camera.cc	(revision 3605)
@@ -51,4 +51,7 @@
 Camera::~Camera ()
 {
+  this->bound = NULL;
+  this->world = NULL;
+
 }
 
@@ -60,5 +63,5 @@
    as smooth camera movement or swaying).
 */
-void Camera::timeSlice (Uint32 deltaT)
+void Camera::tick (Uint32 deltaT)
 {
   if( this->t <= deltaTime)
@@ -198,5 +201,5 @@
   // TO DO: implement options for frustum generation
   //glFrustum(-1.0, 1.0, -1.0, 1.0, 1.5, 250.0);
-  gluPerspective(60, 1.2f, 0.1, 250);
+  gluPerspective(60, 1.2f, 0.1, 2000);
   
   //Vector up(0,0,1);
@@ -276,11 +279,2 @@
 
 
-/**
-   \brief destroy, reset the camera so that it doesn't perform anything anymore
-
-*/
-void Camera::destroy()
-{
-  this->bound = NULL;
-  this->world = NULL;
-}
Index: orxonox/branches/levelloader/src/camera.h
===================================================================
--- orxonox/branches/levelloader/src/camera.h	(revision 3604)
+++ orxonox/branches/levelloader/src/camera.h	(revision 3605)
@@ -7,7 +7,5 @@
 #define _CAMERA_H
 
-#include "stdincl.h"
 #include "world_entity.h"
-
 
 class World;
@@ -56,10 +54,9 @@
  public:
   Camera (World* world);
-  ~Camera ();
+  virtual ~Camera ();
   
-  void timeSlice (Uint32 deltaT);
+  void tick (Uint32 deltaT);
   void apply ();
   void bind (WorldEntity* entity);
-  void destroy();
 
   void setWorld(World* world);  
Index: orxonox/branches/levelloader/src/command_node.cc
===================================================================
--- orxonox/branches/levelloader/src/command_node.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/command_node.cc	(revision 3605)
@@ -14,4 +14,5 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COMMAND_NODE
 
 #include "command_node.h"
@@ -112,5 +113,5 @@
   FILE* stream;
   
-  printf("Loading key bindings from %s\n", filename);
+  PRINTF(4)("Loading key bindings from %s\n", filename);
   
   if( filename == NULL) filename = DEFAULT_KEYBIND_FILE;
@@ -127,5 +128,5 @@
   if( parser.getSection ("Bindings") == -1)
     {
-      printf("Could not find key bindings in %s\n", filename);
+      PRINTF(1)("Could not find key bindings in %s\n", filename);
       return;
     }
@@ -145,9 +146,9 @@
 	{
 	case 0:
-	  printf("Key binding %d(%s) set to %s\n", index[1], SDLKToKeyname( index[1]), valuebuf);
+	  PRINTF(4)("Key binding %d(%s) set to %s\n", index[1], SDLKToKeyname( index[1]), valuebuf);
 	  strcpy (aliases->keys[index[1]], valuebuf);
 	  break;
 	case 1:
-	  printf("Button binding %d(%s) set to %s\n", index[1], SDLBToButtonname( index[1]), valuebuf);
+	  PRINTF(4)("Button binding %d(%s) set to %s\n", index[1], SDLBToButtonname( index[1]), valuebuf);
 	  strcpy (aliases->buttons[index[1]], valuebuf);
 	  break;
@@ -214,4 +215,5 @@
   while( SDL_PollEvent (&event))
     {
+      PRINTF(3)("CommandNode::processLocal() =========================got Event\n");
       memset (cmd.cmd, 0, CMD_LENGHT); 
       switch( event.type)
@@ -267,5 +269,4 @@
 void CommandNode::relay (Command* cmd)
 {
-
   Orxonox *orx = Orxonox::getInstance();
   if( orx->systemCommand (cmd)) return;
@@ -281,5 +282,5 @@
   while( entity != NULL)
     {
-      entity->command (cmd);
+      entity->command (cmd); /*no absorbtion of command! strange*/
       entity = bound->nextElement();
     }
Index: orxonox/branches/levelloader/src/defs/debug.h
===================================================================
--- orxonox/branches/levelloader/src/defs/debug.h	(revision 3604)
+++ orxonox/branches/levelloader/src/defs/debug.h	(revision 3605)
@@ -17,4 +17,8 @@
     \file debug.h
     \brief Handles output to console for different Verbose-Modes.
+
+    There are two main modes HARD and SOFT. HARD is precessed during compileTime where SOFT is for runtime.
+    \li HARD: One can choose between different modes. see: // DEFINE_MODULES \\
+    \li SOFT: If you want each module can have its own variable for processing. just pass it to DEBUG_MODULE_SOFT
 */ 
 
@@ -28,8 +32,5 @@
 #include <stdio.h>
 
-#ifndef DEBUG
-#define DEBUG 4
-#endif
-
+// DEFINE ERROR MODES
 #define NO              0
 #define ERR             1
@@ -37,25 +38,62 @@
 #define INFO            3
 #define DEBUGING        4
-
+#define vDEBUGING       5
+
+extern int verbose;
+
+//definitions
+#ifndef MODULAR_DEBUG
+#define HARD_DEBUG_LEVEL DEBUG
+#define SOFT_DEBUG_LEVEL verbose
+#else /* MODULAR_DEBUG */
+#ifndef DEBUG_MODULE_SOFT 
+#define SOFT_DEBUG_LEVEL verbose
+#else /* DEBUG_MODULE_SOFT */
+#define SOFT_DEBUG_LEVEL DEBUG_MODULE_SOFT
+#endif /* DEBUG_MODULE_SOFT */
+
+#ifndef DEBUG_SPECIAL_MODULE
+#define HARD_DEBUG_LEVEL DEBUG
+#else /* DEBUG_SPECIAL_MODULE */
+// DEFINE MODULES \\
+#define DEBUG_MODULE_ORXONOX            0
+#define DEBUG_MODULE_WORLD              0
+#define DEBUG_MODULE_PNODE              2
+#define DEBUG_MODULE_WORLD_ENTITY       0
+#define DEBUG_MODULE_COMMAND_NODE       0
+
+#define DEBUG_MODULE_IMPORTER           0
+#define DEBUG_MODULE_TRACK_MANAGER      0
+#define DEBUG_MODULE_LIGHT              3
+#define DEBUG_MODULE_PLAYER             0
+#define DEBUG_MODULE_MATH               0
+
+#define DEBUG_MODULE_NULL_PARENT        0
+
+
+#define HARD_DEBUG_LEVEL DEBUG_SPECIAL_MODULE
+#endif /* DEBUG_SPECIAL_MODULE */
+#endif /* MODULAR_DEBUG */
 ///////////////////////////////////////////////////
 /// PRINTF: prints with filename and linenumber ///
 ///////////////////////////////////////////////////
+
 #ifdef DEBUG
-extern int verbose;
+
 #define PRINTF(x) \
            PRINTF ## x
-           
-#if DEBUG >= ERR
+
+#if HARD_DEBUG_LEVEL >= ERR
 #define PRINTF1 \
-    if (verbose >= ERR) \
-      printf("%s:%d::ERROR:", __FILE__, __LINE__) && printf
+    if (SOFT_DEBUG_LEVEL >= ERR) \
+      printf("ERROR::%s:%d:", __FILE__, __LINE__) && printf
 #else 
 #define PRINTF1 if (NO)
 #endif
      
-#if DEBUG >= WARN
+#if HARD_DEBUG_LEVEL >= WARN
 #define PRINTF2 \
-     if (verbose >= WARN) \
-       printf("%s:%d::WARNING:", __FILE__, __LINE__) && printf
+     if (SOFT_DEBUG_LEVEL >= WARN) \
+       printf("WARNING::%s:%d:", __FILE__, __LINE__) && printf
          
 #else 
@@ -63,21 +101,28 @@
 #endif
      
-#if DEBUG >= INFO
+#if HARD_DEBUG_LEVEL >= INFO
 #define PRINTF3 \
-     if (verbose >= INFO) \
-       printf("%s:%d::INFO:", __FILE__, __LINE__) && printf
+     if (SOFT_DEBUG_LEVEL >= INFO) \
+       printf("INFO::%s:%d:", __FILE__, __LINE__) && printf
 #else 
 #define PRINTF3 if (NO)
 #endif
      
-#if DEBUG >= DEBUGING
+#if HARD_DEBUG_LEVEL >= DEBUGING
 #define PRINTF4 \
-     if (verbose >= DEBUGING) \
-       printf("%s:%d::DEBUG:", __FILE__, __LINE__) && printf
+     if (SOFT_DEBUG_LEVEL >= DEBUGING) \
+       printf("DEBUG::%s:%d:", __FILE__, __LINE__) && printf
 #else 
 #define PRINTF4 if (NO)
 #endif
      
-     
+#if HARD_DEBUG_LEVEL >= vDEBUGING
+#define PRINTF5 \
+     if (SOFT_DEBUG_LEVEL >= vDEBUGING) \
+       printf("VERYDEBUG::%s:%d:", __FILE__, __LINE__) && printf
+#else 
+#define PRINTF5 if (NO)
+#endif
+    
 #else  
 #define PRINTF(x) if (NO)
@@ -92,11 +137,10 @@
 ///////////////////////////////////////////////////
 #ifdef  DEBUG
-extern int verbose;
 #define PRINT(x) \
   PRINT ## x
-  
-#if DEBUG >= ERR
+
+#if HARD_DEBUG_LEVEL >= ERR
 #define PRINT1	\
-  if (verbose >= ERR)	\
+  if (SOFT_DEBUG_LEVEL >= ERR)	\
     printf
 #else 
@@ -104,7 +148,7 @@
 #endif
 
-#if DEBUG >= WARN
+#if HARD_DEBUG_LEVEL >= WARN
 #define PRINT2 \
-  if (verbose >= WARN) \
+  if (SOFT_DEBUG_LEVEL >= WARN) \
     printf
 
@@ -113,7 +157,7 @@
 #endif
 
-#if DEBUG >= INFO
+#if HARD_DEBUG_LEVEL >= INFO
 #define PRINT3 \
-  if (verbose >= INFO) \
+  if (SOFT_DEBUG_LEVEL >= INFO) \
     printf
 #else 
@@ -121,10 +165,18 @@
 #endif
 
-#if DEBUG >= DEBUGING
+#if HARD_DEBUG_LEVEL >= DEBUGING
 #define PRINT4 \
-  if (verbose >= DEBUGING) \
+  if (SOFT_DEBUG_LEVEL >= DEBUGING) \
     printf
 #else 
 #define PRINT4 if (NO)
+#endif
+
+#if HARD_DEBUG_LEVEL >= vDEBUGING
+#define PRINT5 \
+     if (SOFT_DEBUG_LEVEL >= vDEBUGING) \
+       printf("VERYDEBUG::%s:%d:", __FILE__, __LINE__) && printf
+#else 
+#define PRINT5 if (NO)
 #endif
 
@@ -144,7 +196,7 @@
            COUT ## x
 
-#if DEBUG >= 1
+#if HARD_DEBUG_LEVEL >= 1
 #define COUT1 \
-    if (verbose >= 1 ) \
+    if (SOFT_DEBUG_LEVEL >= 1 ) \
       cout
 #else 
@@ -152,7 +204,7 @@
 #endif
      
-#if DEBUG >= 2
+#if HARD_DEBUG_LEVEL >= 2
 #define COUT2 \
-     if (verbose >= 2 ) \
+     if (SOFT_DEBUG_LEVEL >= 2 ) \
        cout
 
@@ -161,7 +213,7 @@
 #endif
      
-#if DEBUG >= 3
+#if HARD_DEBUG_LEVEL >= 3
 #define COUT3 \
-     if (verbose >= 3 ) \
+     if (SOFT_DEBUG_LEVEL >= 3 ) \
        cout
 #else
@@ -169,7 +221,7 @@
 #endif
      
-#if DEBUG >= 4
+#if HARD_DEBUG_LEVEL >= 4
 #define COUT4 \
-     if (verbose >= 4 ) \
+     if (SOFT_DEBUG_LEVEL >= 4 ) \
        cout
 #else 
Index: orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.cc
===================================================================
--- orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.cc	(revision 3605)
@@ -19,4 +19,5 @@
 #include "glmenu_imagescreen.h"
 
+#include "stdincl.h"
 #include "material.h"
 
@@ -27,5 +28,5 @@
 GLMenuImageScreen* GLMenuImageScreen::getInstance()
 {
-  if( singletonRef == NULL)
+  if(!singletonRef)
     singletonRef = new GLMenuImageScreen ();
   return singletonRef;
@@ -45,5 +46,4 @@
 /**
    \brief standard deconstructor
-
    \todo this deconstructor is not jet implemented - do it
 */
@@ -53,5 +53,4 @@
     delete backMat;
 }
-
 
 /**
@@ -171,5 +170,4 @@
   glDisable(GL_LIGHTING);
 
-  backMat->select();
   glBegin(GL_QUADS);
   glColor3f(0.96, 0.84, 0.34);
@@ -210,5 +208,5 @@
   glEnd();
 
-  glEnable(GL_TEXTURE_2D);
+  backMat->select();
   glBegin(GL_QUADS);
   glTexCoord2i(0, 0); glVertex2i(offsetX, offsetY);
Index: orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.h
===================================================================
--- orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.h	(revision 3604)
+++ orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.h	(revision 3605)
@@ -8,6 +8,6 @@
 #define _GLMENU_IMAGESCREEN_H
 
-#include "stdincl.h"
-class Texture;
+#include "base_object.h"
+
 class Material;
 
@@ -18,6 +18,6 @@
 
  public:
-  ~GLMenuImageScreen ();
-
+  virtual ~GLMenuImageScreen ();
+  
   static GLMenuImageScreen* getInstance();
 
Index: orxonox/branches/levelloader/src/keynames.cc
===================================================================
--- orxonox/branches/levelloader/src/keynames.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/keynames.cc	(revision 3605)
@@ -15,4 +15,6 @@
 
 #include "keynames.h"
+
+#include "stdincl.h"
 
 #include <string.h>
Index: orxonox/branches/levelloader/src/keynames.h
===================================================================
--- orxonox/branches/levelloader/src/keynames.h	(revision 3604)
+++ orxonox/branches/levelloader/src/keynames.h	(revision 3605)
@@ -7,15 +7,4 @@
 #ifndef _KEYNAMES_H
 #define _KEYNAMES_H
-
-
-#ifdef __WIN32__
-#include <windows.h>
-#endif
-
-#ifndef __APPLE__
-#include <SDL/SDL.h>
-#else
-#include <SDL.h>
-#endif
 
 /**
Index: orxonox/branches/levelloader/src/lib/coord/helper_parent.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/helper_parent.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/lib/coord/helper_parent.cc	(revision 3605)
@@ -39,4 +39,6 @@
    \todo this deconstructor is not jet implemented - do it
 */
-HelperParent::~HelperParent () {}
+HelperParent::~HelperParent () 
+{
 
+}
Index: orxonox/branches/levelloader/src/lib/coord/helper_parent.h
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/helper_parent.h	(revision 3604)
+++ orxonox/branches/levelloader/src/lib/coord/helper_parent.h	(revision 3605)
@@ -17,6 +17,5 @@
  public:
   HelperParent ();
-  ~HelperParent ();
-
+  virtual ~HelperParent ();
 
 };
Index: orxonox/branches/levelloader/src/lib/coord/null_parent.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/null_parent.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/lib/coord/null_parent.cc	(revision 3605)
@@ -16,4 +16,5 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_NULL_PARENT
 
 #include "null_parent.h"
@@ -26,5 +27,5 @@
 NullParent* NullParent::getInstance ()
 {
-  if( singletonRef == NULL)
+  if(!singletonRef)
     singletonRef = new NullParent ();
   return singletonRef;
@@ -36,16 +37,20 @@
    \todo this constructor is not jet implemented - do it
 */
-NullParent::NullParent () 
+NullParent::NullParent () : PNode (new Vector(0,0,0), NULL)
 {
+  PRINTF(4)("NullParent::NullParent() - making new NullParent, there can only be one..\n");
   this->parent = this;
-  this->mode = ALL;
+  this->mode = PNODE_ALL;
+  this->setName("NullParent");
 }
 
 
-NullParent::NullParent (Vector* absCoordinate)
+NullParent::NullParent (Vector* absCoordinate) : PNode (new Vector(0,0,0), NULL)
 {
+  singletonRef = this;
   this->parent = this;
-  this->mode = ALL;
+  this->mode = PNODE_ALL;
   this->absCoordinate = *absCoordinate;
+  this->setName("NullParent");
 }
 
@@ -58,10 +63,7 @@
 NullParent::~NullParent () 
 {
-  delete singletonRef;
+  //delete singletonRef;
   singletonRef = NULL;
 }
-
-
-
 
 /**
@@ -72,6 +74,8 @@
    worry, normaly...
 */
-void NullParent::update (float timeStamp)
+void NullParent::update ()
 {
+
+  PRINTF(4)("NullParent::update - (%f, %f, %f)\n", this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
   this->absCoordinate = this->relCoordinate;
   this->absDirection = parent->getAbsDir () * this->relDirection;
@@ -85,5 +89,5 @@
       if( this->bRelDirChanged || this->bAbsDirChanged)
 	pn->parentDirChanged ();
-      pn->update (timeStamp);
+      pn->update ();
       pn = this->children->nextElement ();
     }
Index: orxonox/branches/levelloader/src/lib/coord/null_parent.h
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/null_parent.h	(revision 3604)
+++ orxonox/branches/levelloader/src/lib/coord/null_parent.h	(revision 3605)
@@ -16,13 +16,13 @@
  public:
   static NullParent* getInstance ();
-  ~NullParent ();
-  
-  static NullParent* singletonRef;
+  virtual ~NullParent ();
 
-  virtual void update (float timeStamp);
+
+  virtual void update ();
 
  private:
   NullParent ();
   NullParent (Vector* absCoordinate);
+  static NullParent* singletonRef;
 
 };
Index: orxonox/branches/levelloader/src/lib/coord/p_node.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/p_node.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/lib/coord/p_node.cc	(revision 3605)
@@ -13,14 +13,15 @@
    ### File Specific:
    main-programmer: Patrick Boenzli
-   co-programmer: ...
-
-   \todo Null-Parent => center of the coord system - singleton
+   co-programmer: 
+
    \todo Smooth-Parent: delay, speed
-   \todo destroy the stuff again, delete...
-*/
-
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_PNODE
 
 #include "p_node.h"
 
+#include "null_parent.h"
+#include "vector.h"
 
 using namespace std;
@@ -34,10 +35,8 @@
 PNode::PNode () 
 {
-  this->children = new tList<PNode>();
-  this->bRelCoorChanged = true;
-  this->bAbsCoorChanged = false;
-  this->bRelDirChanged = true;
-  this->bAbsDirChanged = false;
-  this->parent = NULL;
+  init(NULL);
+
+  NullParent* np = NullParent::getInstance();
+  np->addChild(this);
   this->objectName = NULL;
 }
@@ -51,18 +50,15 @@
 PNode::PNode (Vector* absCoordinate, PNode* parent )
 {
+  this->init(parent);
+
   this->absCoordinate = *absCoordinate;
-  this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
-  
-  this->children = new tList<PNode>();
-  this->bRelCoorChanged = true;
-  this->bAbsCoorChanged = false;
-  this->bRelDirChanged = true;
-  this->bAbsDirChanged = false;
-  this->parent = parent;
-  this->objectName = NULL;
-  
-  parent->addChild (this);
-}
-
+  if (parent != NULL)
+    {
+      this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
+      parent->addChild (this);
+    }
+  else 
+    this->relCoordinate = Vector(0,0,0);
+}
 
 /**
@@ -80,9 +76,32 @@
   delete &this->absDirection;
   */
-  this->parent = NULL;
+  //this->parent = NULL;
   if( this->objectName) delete this->objectName;
   /* there is currently a problem with cleaning up - fix*/
-}
-
+
+  PNode* pn = this->children->enumerate();
+  while( pn != NULL) 
+    { 
+      delete pn;
+      pn = this->children->nextElement();
+
+    }
+   
+  /* this deletes all children in the list */
+  delete this->children;
+
+  delete []this->objectName;
+}
+
+void PNode::init(PNode* parent)
+{
+  this->children = new tList<PNode>();
+  this->bRelCoorChanged = true;
+  this->bAbsCoorChanged = false;
+  this->bRelDirChanged = true;
+  this->bAbsDirChanged = false;
+  this->parent = parent; 
+  this->objectName = NULL;
+}
 
 /**
@@ -91,4 +110,5 @@
    cleans up all pnodes
 */
+/*
 void PNode::destroy ()
 {
@@ -99,7 +119,10 @@
       pn = this->children->nextElement();
     } 
+  // this deletes all children in the list 
   this->children->destroy ();
-}
-
+
+  static_cast<BaseObject*>(this)->destroy();
+}
+*/
 
 /**
@@ -262,6 +285,4 @@
 {}
 
-
-
 /**
    \brief adds a child and makes this node to a parent
@@ -283,9 +304,14 @@
    use this to add a child to this node.
 */
-void PNode::addChild (PNode* pNode, parentingMode mode)
-{
-  pNode->mode = mode;
+void PNode::addChild (PNode* pNode, int parentingMode)
+{
+  if( pNode->parent != NULL )
+    {
+      PRINTF(2)("PNode::addChild() - reparenting node: removing it and adding it again\n");
+      pNode->parent->children->remove(pNode);
+    }
+  pNode->mode = parentingMode;
   pNode->parent = this;
-  this->children->add (pNode);
+  this->children->add(pNode);
 }
 
@@ -294,8 +320,30 @@
    \brief removes a child from the node
    \param pNode the child to remove from this pNode.
+
+   Children from pNode will not be lost, they are referenced to NullPointer
 */
 void PNode::removeChild (PNode* pNode)
 {
+  pNode->remove();
   this->children->remove (pNode);
+  pNode->parent = NULL;
+}
+
+
+/**
+   \brief remove this pnode from the tree and adds all following to NullParent
+
+   this can be the case, if an entity in the world is been destroyed.
+*/
+void PNode::remove()
+{
+  NullParent* np = NullParent::getInstance();
+  PNode* pn = this->children->enumerate();
+  while( pn != NULL) 
+    { 
+      this->children->remove(pn);
+      np->addChild(pn, pn->getMode());
+      pn = this->children->nextElement();
+    }
 }
 
@@ -307,6 +355,7 @@
 void PNode::setParent (PNode* parent)
 {
-  this->parent = parent;
-}
+  parent->addChild(this);
+}
+
 
 /**
@@ -314,7 +363,17 @@
    \param mode the mode of the bind-type.
 */
-void PNode::setMode (parentingMode mode)
-{
-  this->mode = mode;
+void PNode::setMode (int parentingMode)
+{
+  this->mode = parentingMode;
+}
+
+
+/**
+   \brief gets the mode of this parent manualy
+   \return the mode of the bind-type.
+*/
+int PNode::getMode()
+{
+  return this->mode;
 }
 
@@ -351,42 +410,59 @@
    worry, normaly...
 */
-void PNode::update (float timeStamp)
-{
-  printf ("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
-
-      if( this->mode == MOVEMENT || this->mode == ALL)
+void PNode::update ()
+{
+  PRINTF(2)("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
+  // printf("%s", this->objectName);
+  if(this->mode & PNODE_MOVEMENT )
+    {
+      if( this->bAbsCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
 	{
-	  if( this->bAbsCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
+	  /* if you have set the absolute coordinates this overrides all other changes */
+	  this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
+	}
+      else if( this->bRelCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
+	{
+	  /*this is bad style... must be deleted later - just for testing*/
+	  if( this->parent == NULL)
 	    {
-	      printf("PNode::update () - this->bAbsCoorChanged = true\n");
-	      /* if you have set the absolute coordinates this overrides all other changes */
-	      this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
+	      this->absCoordinate = this->relCoordinate;
 	    }
-	  else if( this->bRelCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
-	    {
-	      /*this is bad style... must be deleted later - just for testing*/
-	      if( this->parent == NULL)
-		{
-		this->absCoordinate = this->relCoordinate;
-		}
-	      else
-		this->absCoordinate = parent->getAbsCoor () + this->relCoordinate;	      /* update the current absCoordinate */
-	    }
+	  else
+	    this->absCoordinate = parent->getAbsCoor() + this->relCoordinate;	      /* update the current absCoordinate */
 	}
-      
-      if( this->mode == ROTATION && this->mode == ALL)
+    }
+  
+  if( this->mode & PNODE_LOCAL_ROTATE)
+    {
+      if( this->bAbsDirChanged /*&& this->timeStamp != DataTank::timeStamp*/)
 	{
-	  if( this->bAbsDirChanged /*&& this->timeStamp != DataTank::timeStamp*/)
-	    {
-	      /* if you have set the absolute coordinates this overrides all other changes */
-	      this->relDirection = this->absDirection - parent->getAbsDir ();
-	    }
-	  else if( this->bRelDirChanged /*&& this->timeStamp != DataTank::timeStamp*/)
-	    {
-	      /* update the current absDirection - remember * means rotation around sth.*/
-	      this->absDirection = parent->getAbsDir () * this->relDirection;
-	    }
-	}    
-      // }
+	  /* if you have set the absolute coordinates this overrides all other changes */
+	  this->relDirection = this->absDirection - parent->getAbsDir();
+	}
+      else if( this->bRelDirChanged /*&& this->timeStamp != DataTank::timeStamp*/)
+	{
+	  /* update the current absDirection - remember * means rotation around sth.*/
+	  this->absDirection = parent->getAbsDir() * this->relDirection;
+	}
+    }
+  
+  if( this->mode & PNODE_ROTATE_MOVEMENT)
+    {
+      if( this->bAbsCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
+	{
+	  /* if you have set the absolute coordinates this overrides all other changes */
+	  this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
+	}
+      else if( this->bRelCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
+	{
+	  /*this is bad style... must be deleted later - just for testing*/
+	  if( this->parent == NULL)
+	    this->absCoordinate = this->relCoordinate;
+	  else
+	    this->absCoordinate = parent->getAbsCoor() + parent->getAbsDir().apply(this->relCoordinate);	      /* update the current absCoordinate */
+	}
+    }
+  
+  
   PNode* pn = this->children->enumerate();
   while( pn != NULL) 
@@ -397,5 +473,5 @@
       if( this->bRelDirChanged || this->bAbsDirChanged)
 	pn->parentDirChanged ();
-      pn->update(timeStamp);
+      pn->update();
       pn = this->children->nextElement();
     }
@@ -415,5 +491,5 @@
 void PNode::processTick (float dt)
 {
-  this->tick (dt);
+  //this->tick (dt);
   PNode* pn = this->children->enumerate();
   while( pn != NULL) 
@@ -424,9 +500,4 @@
 }
 
-/**
-   \param dt time to tick
-*/
-void PNode::tick (float dt)
-{}
 
 /**
@@ -435,5 +506,5 @@
 void PNode::debug()
 {
-  printf("PNode::debug() - absCoord: (%f, %f, %f)\n", 
+  PRINTF(2)("PNode::debug() - absCoord: (%f, %f, %f)\n", 
 	 this->absCoordinate.x, 
 	 this->absCoordinate.y,
@@ -451,16 +522,8 @@
 void PNode::setName (const char* newName)
 {
-	int l = strlen( newName);
-	
-	if( this->objectName != NULL) delete this->objectName;
-	this->objectName = NULL;
-	
-	if( newName != NULL)
-	{
-		this->objectName = new char[l+1];
-		
-		for( int i = 0; i < l+1; i++)
-			this->objectName[i] = newName[i];
-	}
+  if (this->objectName)
+    delete []this->objectName;
+  this->objectName = new char[strlen(newName)+1];
+  strcpy(this->objectName,newName);
 }
 
@@ -473,2 +536,3 @@
   return this->objectName;
 }
+
Index: orxonox/branches/levelloader/src/lib/coord/p_node.h
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/p_node.h	(revision 3604)
+++ orxonox/branches/levelloader/src/lib/coord/p_node.h	(revision 3605)
@@ -22,12 +22,23 @@
 #define _P_NODE_H
 
-#include "stdincl.h"
+#include "base_object.h"
 
+// FORWARD DEFINITION \\
 class PNode; /* forward decleration, so that parentEntry has access to PNode */
+class Quaternion;
+class Vector;
 
 //! enumeration for the different translation-binding-types
-typedef enum parentingMode {MOVEMENT = 0, ROTATION, ALL};
+//typedef enum parentingMode {PNODE_LOCAL_ROTATE, PNODE_ROTATE_MOVEMENT, PNODE_ALL, PNODE_MOVEMENT, PNODE_ROTATE_AND_MOVE};
+// linkage modes
+#define PNODE_LOCAL_ROTATE       1    //!< Rotates all the children around their centers.
+#define PNODE_ROTATE_MOVEMENT    2    //!< Moves all the children around the center of their parent, without the rotation around their own centers.
+#define PNODE_MOVEMENT           4    //!< Moves all children along with the parent.
+// special linkage modes
+#define PNODE_ALL                3    //!< Moves all children around the center of their parent, and also rotates their centers
+#define PNODE_ROTATE_AND_MOVE    5    //!< Rotates all children around their axis, and moves them as the Parent Moves, but does not rotate around the center of their parent.
+
 //! The default mode of the translation-binding.
-#define DEFAULT_MODE ALL
+#define DEFAULT_MODE PNODE_ALL
 
 //! Patent Node is a Engine to calculate the position of an Object in respect to the position of its parent.
@@ -39,10 +50,8 @@
   virtual ~PNode ();
 
-  void destroy ();
-
   PNode* parent;            //!< a pointer to the parent node
   tList<PNode>* children;   //!< list of the children
 
-  parentingMode mode;       //!< the mode of the binding
+
 
   Vector getRelCoor ();
@@ -62,14 +71,17 @@
 
   void addChild (PNode* pNode);
-  void addChild (PNode* pNode, parentingMode mode);
+  void addChild (PNode* pNode, int parentingMode);
   void removeChild (PNode* pNode);
+  void remove();
+
+
   void setParent (PNode* parent);
   void parentCoorChanged ();
   void parentDirChanged ();
-  void setMode (parentingMode mode);
+  void setMode (int parentingMode);
+  int getMode();
 
-  virtual void update (float timeStamp);
+  virtual void update ();
   void processTick (float dt);
-  virtual void tick (float dt);
 
   void setName (const char* newName);
@@ -79,4 +91,8 @@
   void debug ();
 
+ private:
+  void init(PNode* parent);
+
+ protected:
   float timeStamp;         //!< this the timeStamp of when the abs{Coordinat, Direction} has been calculated
   char* objectName;        //!< The name of the Object
@@ -91,5 +107,8 @@
   Quaternion absDirection; //!< absolute direvtion in the world ( from (0,0,1) )
 
+  int mode;                //!< the mode of the binding
+
 };
 
 #endif /* _P_NODE_H */
+ 
